using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Runtime.Serialization;

using Syncfusion.Drawing;
using Syncfusion.Windows.Forms.Grid;

namespace ExcelMarker
{
	public class ImageCellModel : GridStaticCellModel
	{
		//private Image image;
		protected ImageCellModel(SerializationInfo info, StreamingContext context)
			: base(info, context)
		{
		}

		public ImageCellModel(GridModel grid)
			: base(grid)
		{
				
		}
	
		public override GridCellRendererBase CreateRenderer(GridControlBase control)
		{
			return new ImageCellRenderer(control, this);
		}

	}

	/// <summary>
	///    Summary description for DragButton.
	/// </summary>
	public class ImageCellRenderer: GridStaticCellRenderer
	{
		public ImageCellRenderer(GridControlBase grid, GridCellModelBase cellModel)
			: base(grid, cellModel)
		{
				
		}

		protected override void OnDraw(System.Drawing.Graphics g, System.Drawing.Rectangle clientRectangle, int rowIndex, int colIndex, Syncfusion.Windows.Forms.Grid.GridStyleInfo style)
		{
			if (clientRectangle.IsEmpty)
				return;
			// CellLayout layout = GetCellLayout(int rowIndex, int colIndex, GridStyleInfo style)

			if(style.Tag is Bitmap)
			{
				g.DrawImage((Bitmap) style.Tag, clientRectangle);
			}
		}
	}
}
